// PublishDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "PublishDlg.h"
#include <io.h>
#include <direct.h>
#include <stdlib.h>
#include "StdioFileEx.h"

#pragma warning (disable : 4244)
#pragma warning (disable : 4800)
#pragma warning (disable : 4018)
#pragma warning (disable : 4010)
#pragma warning (disable : 4663)

#if _MSC_VER >= 1300
#include <fstream>
#include <iosfwd>
using namespace std;
#else
#include <fstream.h>
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPublishDlg dialog


CPublishDlg::CPublishDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPublishDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPublishDlg)
	m_strIndex = _T("index");
	m_strPath = _T("c:\\temp\\");
	//}}AFX_DATA_INIT
//	EnableVisualManagerStyle(TRUE, TRUE);
}


void CPublishDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPublishDlg)
	DDX_Control(pDX, IDC_EDIT_INDEX, m_editIndex);
	DDX_Control(pDX, IDC_LIST_PUBLISH, m_listPublish);
	DDX_Control(pDX, IDC_LIST_OLD, m_listOld);
	DDX_Control(pDX, IDC_EDIT_PATH, m_edtPath);
	DDX_Text(pDX, IDC_EDIT_INDEX, m_strIndex);
	DDX_Text(pDX, IDC_EDIT_PATH, m_strPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPublishDlg, CDialog)
	//{{AFX_MSG_MAP(CPublishDlg)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SYS1, OnButton1)
	ON_LBN_DBLCLK(IDC_LIST_OLD, OnDblclkListOld)
	ON_LBN_DBLCLK(IDC_LIST_PUBLISH, OnDblclkListPublish)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPublishDlg message handlers

BOOL CPublishDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	CString strOtherFile;
	strOtherFile = strPathX+_T("\\Shapes");
	AddInfoToTab(strOtherFile);

	CStringArray mArs;
	FOStringToStringArray(strPages, _T("@"), mArs);
	
 
	if(mArs.GetSize() > 0)
	{
		CListBox *pListNew = (CListBox *)GetDlgItem(IDC_LIST_PUBLISH);
		for(int x = 0; x < mArs.GetSize(); x++)
		{
			CString str = mArs.GetAt(x);
	  
			pListNew->InsertString(-1, str);
		 
			
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPublishDlg::FindIn(const CString &strFile)
{
	CStringArray mArs;
	FOStringToStringArray(strPages, _T("@"), mArs);

	CString strFind = strFile;
	strFind.MakeLower();
	strFind.TrimRight();
	if(mArs.GetSize() > 0)
	{
		for(int x = 0; x < mArs.GetSize(); x++)
		{
			CString str = mArs.GetAt(x);
			str.MakeLower();
			str.TrimRight();
			if(str == strFind)
			{
				return TRUE;
			}

		}
	}
	return FALSE;
}

void CPublishDlg::AddInfoToTab(const CString &strFolder)
{
	CFileFind ff;
	BOOL res = ff.FindFile(strFolder + _T("\\*.*"));
	CListBox *pListBox = (CListBox *)GetDlgItem(IDC_LIST_OLD);
	int nCount = 0;
	
 	CFileFind fItem;
	BOOL resItem = fItem.FindFile(strFolder + _T("\\*.trs"));
	while (resItem)
	{// AddItem
		resItem = fItem.FindNextFile();
 		if (!fItem.IsDirectory() && !fItem.IsDots())
		{
 			CString strPath = fItem.GetFilePath();
			CString strTitle = fItem.GetFileTitle() + _T(".trs");
			CString strCheck = strTitle;
			strCheck.MakeLower();
			strCheck.TrimLeft();
			strCheck.TrimRight();
			
			if(!FindIn(strCheck))
			{
				pListBox->InsertString(-1, strTitle);
				nCount ++;
			}
		}
	}
	
	if(nCount > 0)
		pListBox->SetCurSel(0);
}

void CPublishDlg::OnButtonAdd() 
{
	// TODO: Add your control notification handler code here
	CListBox *pListOld = (CListBox *)GetDlgItem(IDC_LIST_OLD);
	CListBox *pListNew = (CListBox *)GetDlgItem(IDC_LIST_PUBLISH);
	int nIndex = pListOld->GetCurSel();
	int nCount = pListOld->GetCount();
	if(nIndex >= 0)
	{
		CString strOld;
		pListOld->GetText(nIndex, strOld);
		CString strNew;
		if(nIndex + 1 < nCount)
		{
			pListOld->GetText(nIndex +1, strNew);
		}
		else
		{
			if(nIndex - 1 <= 0)
			{
				pListOld->GetText(0, strNew);
			}
			else 
			{
				if(nCount > 1)
					pListOld->GetText(nIndex - 1, strNew);
			}
		}

		pListNew->AddString(strOld);
		pListOld->DeleteString(nIndex);
		pListNew->SelectString(-1,strOld);
		if(!strNew.IsEmpty())
			pListOld->SelectString(-1, strNew);
	}
}

void CPublishDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	CListBox *pListOld = (CListBox *)GetDlgItem(IDC_LIST_PUBLISH);
	CListBox *pListNew = (CListBox *)GetDlgItem(IDC_LIST_OLD);
	int nIndex = pListOld->GetCurSel();
	int nCount = pListOld->GetCount();
	if(nIndex >= 0)
	{
		CString strOld;
		pListOld->GetText(nIndex, strOld);
		CString strNew;
		if(nIndex + 1 < nCount)
		{
			pListOld->GetText(nIndex +1, strNew);
		}
		else
		{
			if(nIndex - 1 <= 0)
			{
				pListOld->GetText(0, strNew);
			}
			else 
			{
				if(nCount > 1)
					pListOld->GetText(nIndex - 1, strNew);
			}
		}
		
		pListNew->AddString(strOld);
		pListOld->DeleteString(nIndex);
		pListNew->SelectString(-1,strOld);
		if(!strNew.IsEmpty())
			pListOld->SelectString(-1, strNew);
	}
}

static int CALLBACK FOPBrowseForFolderProc( HWND hwnd, UINT w, LPARAM l, LPARAM lpData )
{
	UNUSED_ALWAYS(l);
	if( w == BFFM_INITIALIZED )
	{
		::SendMessage( hwnd, BFFM_SETSELECTION, (WPARAM)FALSE, lpData );
	}
	return 0;
}

BOOL CPublishDlg::BrowseForFolder( CString& strPath )
{
	strPath = m_strPath;
	BOOL bRet = FALSE;

	LPMALLOC pMalloc = NULL;
	HRESULT hr = ::SHGetMalloc(&pMalloc);
	ASSERT(SUCCEEDED(hr));

	if(SUCCEEDED(hr))
	{
		LPSHELLFOLDER pShellFolder = NULL;

		hr = ::SHGetDesktopFolder(&pShellFolder);
	
		if(SUCCEEDED(hr))
		{
			if( strPath.IsEmpty() )
			{
				TCHAR temp[_MAX_PATH];
				::GetCurrentDirectory( sizeof(temp), temp );
				strPath = temp;
			}

			OLECHAR olePath[_MAX_PATH];
			::ZeroMemory( olePath, sizeof(olePath) );

			LPITEMIDLIST pidl = NULL;
			DWORD dwEaten   = 0;
			DWORD dwAttribs = 0;

#ifndef UNICODE
			char* pszPath = strPath.GetBuffer(strPath.GetLength()+1);
			::MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, pszPath, -1, olePath, _MAX_PATH );
			strPath.ReleaseBuffer(-1);
#else
			_tcsncpy( olePath, (LPCTSTR)strPath, _MAX_PATH );
#endif

			hr = pShellFolder->ParseDisplayName( NULL, NULL, olePath, &dwEaten, &pidl, &dwAttribs );
	
			if(SUCCEEDED(hr))
			{
				TCHAR szPath[_MAX_PATH];
				::ZeroMemory( szPath, sizeof(szPath) );

				BROWSEINFO bi;
				::ZeroMemory(&bi, sizeof(bi));

				bi.hwndOwner = (m_pParentWnd != NULL) ? m_pParentWnd->GetSafeHwnd() : NULL;
				bi.pidlRoot = NULL;
#if (_MFC_VER < 0x0420) & defined(UNICODE)
				bi.pszDisplayName = (char *)&szPath[0];
				bi.lpszTitle = (const char *)_T("Path setting...");
#else
				bi.pszDisplayName = szPath;
				bi.lpszTitle = _T("Path setting...");
#endif
				bi.ulFlags = 0;
				bi.lpfn = FOPBrowseForFolderProc;
				bi.lParam = (LPARAM)pidl;

				LPITEMIDLIST pidlPath = ::SHBrowseForFolder(&bi);

				if( pidlPath != NULL )
				{
#if (_MFC_VER < 0x0420) & defined(UNICODE)
					if( ::SHGetPathFromIDList(pidlPath,(char *)&szPath[0]) )
#else
					if( ::SHGetPathFromIDList(pidlPath,szPath) )
#endif
					{
						bRet = TRUE;
						strPath = szPath;
						if(strPath.Right(1) != _T("\\"))
							strPath += _T("\\");

						pMalloc->Free(pidlPath);
					}
				}

				pMalloc->Free(pidl);
			}

			pShellFolder->Release();
			pShellFolder = NULL;
		}

		pMalloc->Release();
		pMalloc = NULL;
	}

	return bRet;
}

void CPublishDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here

	BrowseForFolder(m_strPath);
	m_edtPath.SetWindowText(m_strPath);
}

BOOL FOPCloseFile(CFile *pFile)
{
	BOOL bRetVal = TRUE;
	
	TRY
	{
		pFile->Close();
	}
	CATCH(CFileException, e)
	{
		bRetVal = FALSE;
	}
	END_CATCH
		
	return bRetVal;
}

BOOL FOPCopyFile(const CString& SourceFileName, const CString& DestFileName, const unsigned long lBuffSize /* = 10240 */)
{
	BOOL    bRetVal  = TRUE;
	char *  pBuff    = new char[lBuffSize];
	CFile Source;
	CFile Dest;

	CFileStatus destStatus;
	if ((CFile::GetStatus(DestFileName, destStatus)))
	{
		delete [] pBuff;
		pBuff = NULL;
		
		return FALSE;
	}

	if (Source.Open((const TCHAR *) SourceFileName, CFile::modeRead))
	{
		if (Dest.Open((const TCHAR *) DestFileName, CFile::modeCreate | CFile::modeWrite))
		{
			DWORD  dwLength = Source.GetLength();
			while (dwLength > 0)
			{
				UINT nRead = Source.Read(pBuff, (UINT) lBuffSize);
				if (nRead)
				{
					Dest.Write(pBuff, nRead);
				}
				
				dwLength -= nRead;
			}
			
			FOPCloseFile(&Source);
			FOPCloseFile(&Dest);
		}
		else
		{
			FOPCloseFile(&Source);
			
			bRetVal = FALSE;
		}
	}
	else
	{
		bRetVal = FALSE;
	}
	
	delete [] pBuff;
	pBuff = NULL;
	
	return bRetVal;
}

BOOL FOPMakeDirectory(const CString& NewDirectory)
{
#ifdef WIN32
	
	SECURITY_ATTRIBUTES security_attrib;
	security_attrib.nLength = sizeof(SECURITY_ATTRIBUTES);
	security_attrib.lpSecurityDescriptor = NULL;
	security_attrib.bInheritHandle = TRUE;
	
	BOOL bRetVal = CreateDirectory((const TCHAR *) NewDirectory, &security_attrib);
	return bRetVal;
	
#else
	
	int nRetVal = _tmkdir((const char *) NewDirectory);
	if (nRetVal == -1)
	{
		return FALSE;
	}
	
	return TRUE;
	
#endif
}

void CPublishDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();
//	m_editIndex.GetWindowText(m_strIndex);
//	m_edtPath.GetWindowText(m_strPath);

	CListBox *pListOld = (CListBox *)GetDlgItem(IDC_LIST_PUBLISH);
	int nIndex = pListOld->GetCurSel();
	int nCount = pListOld->GetCount();
	if(nCount > 0)
	{
		if(1)
		{
			CString strPathX = AfxGetApp()->m_pszHelpFilePath;
			strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
			
			CString strFile2 = m_strPath+_T("Shapes");
			FOPMakeDirectory(strFile2);
			CString strPath2 = m_strPath+_T("Shapes\\");
			
			CStringArray m_Files;
			CString strOtherFile;
			strOtherFile = strPathX+_T("\\Shapes\\");
			for(int x = 0; x < nCount; x++)
			{
				CString strOld;
				pListOld->GetText(x, strOld);
				
				m_Files.Add(strOld);
			}
			
			FOStringArrayToString(m_Files, _T("@"), strPages);
		}
	 
	}
	else
	{
		AfxMessageBox(_T("Please select a list of trs files for publishing, and then try again!..."), MB_OK|MB_ICONINFORMATION);
		pListOld->SetFocus();
		return;
	}
	CDialog::OnOK();
}

void CPublishDlg::OnDblclkListOld() 
{
	// TODO: Add your control notification handler code here
	OnButtonAdd();
}

void CPublishDlg::OnDblclkListPublish() 
{
	// TODO: Add your control notification handler code here
	OnButtonRemove();
}
