#if !defined(AFX_SVSAVEASTEMPLATEDLG_H__C5002BD7_6166_45A2_BF0F_6457E972F7AF__INCLUDED_)
#define AFX_SVSAVEASTEMPLATEDLG_H__C5002BD7_6166_45A2_BF0F_6457E972F7AF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SVSaveAsTemplateDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSVSaveAsTemplateDlg dialog

 
//===========================================================================
// Summary:
//     The CSVSaveAsTemplateDlg class derived from CDialog
//      S V Save As Template Dialog
//===========================================================================

class CSVSaveAsTemplateDlg : public CDialog
{
// Construction
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// S V Save As Template Dialog, Constructs a CSVSaveAsTemplateDlg object.
	//		Returns A  value.  
	// Parameters:
	//		pParent---pParent, A pointer to the CWnd or NULL if the call failed.
	CSVSaveAsTemplateDlg(CWnd* pParent = NULL);   // standard constructor

public:
 
	// m_strPath, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strPath;
// Dialog Data
	//{{AFX_DATA(CSVSaveAsTemplateDlg)
	enum { IDD = IDD_SV_SA_TEMPLATE_DLG };
	CComboBox	m_cbType;
	CString	m_strName;
	CString	m_strType;
	CString	m_strCategoryName;
	CString	m_strPage;
	//}}AFX_DATA

	CString m_strImage;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSVSaveAsTemplateDlg)
	protected:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Do Data Exchange, Do a event. 
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		pDX---D X, A pointer to the CDataExchange or NULL if the call failed.
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSVSaveAsTemplateDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnSvSaveAsTemplateDlgCreate();
	afx_msg void OnSvSaveAsTemplateRemove();
	afx_msg void OnButtonPage();
	afx_msg void OnButtonImage();
	//}}AFX_MSG
	
	//-----------------------------------------------------------------------
	// Summary:
	// E C L A R E_ M E S S A G E_ M A P, None Description.
	//		Returns A  value.
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SVSAVEASTEMPLATEDLG_H__C5002BD7_6166_45A2_BF0F_6457E972F7AF__INCLUDED_)
